
include "/hd0/1/macros.inc"

MEOS_APP_START

char_coord_x = 10
char_coord_y = 10
char_width  = 6
char_height = 9

CODE

redraw:
        call    draw_window
wait_event:
        mcall   10
        dec     eax
        jz      redraw
        dec     eax
        jz      key
; button pressed; we have only one button, close
        mcall   -1
key:
; key pressed, read it and ignore
        mcall   2
        jmp     wait_event

draw_window:
        mcall   12, 1           ; start redraw
        mcall   0, <10,150>, <10,50>, 0x33FFFFFF, , header      ; define&draw window
;       mcall   4, <30,10>, 0x80000000, string                  ; display string
        mcall   12, 2           ; end redraw

        ; draw one char in buffer.
        xor     eax, eax
        mov      al, 4
        mov     ebx, char_coord_x
        shl     ebx, 16
        add     ebx, char_coord_y
        xor     ecx, ecx
        mov      cl, 00001000b    ; XY ; X = font type 6x9 cp866 ; Y = output in buffer.
        ror     ecx, 8
        add     ecx, 0x00ff0000   ; char color is red.
        mov     edx, string       ; edx = char start address.
        mov     esi, 1            ; use one char.
        mov     edi, char_addr    ; edi = buffer address for char.
        int     0x40

        ; draw character image.
        xor     eax, eax
        mov      al, 65
        mov     ebx, char_addr    ; ebx = buffer address with char.
        mov     ecx, char_width
        shl     ecx, 16
        add     ecx, char_height
        mov     edx, char_coord_x
        shl     edx, 16
        add     edx, char_coord_y
        mov     esi, 32           ; 32 bits per pixel.
        mov     edi, 0
        mov     ebp, 0
        int     0x40

        ret

DATA
header  db      'Character test',0
string  db      'Hello, World!',0

char_addr:  db  char_width*char_height*4  dup (0x33)

UDATA

MEOS_APP_END



